/**************************************************************
SPI-Master Demo Programm
B. Hayer 26.06.2005
Gibt Daten ber SPI aus.
				MISO(Master) -> MISO(Slave)
				MOSI(Master) -> MOSI(Slave)
				SCK(Master)  -> SCK(Slave)
				PB4(Master)	 -> SS(Slave)
**************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>


#ifndef F_CPU
#define F_CPU 8000000UL
#endif


void spi_master_init (void);
void spi_putc (unsigned char data);


SIGNAL (SIG_SPI) 										//SPI Interrupt Service-Routine
{
	return;
}



void spi_puts(const char *s )
{
    while (*s) 										//solange Zeichen da sind
      spi_putc(*s++);									//Zeichen senden, Zhler inkrementieren

}

void spi_master_init (void) {
	DDRB = (1<<PB0) | (1<<PB5) | (1<<PB7) | (1<<PB4);	// set SCK,MOSI,PB0 (SS) output
	DDRB &= ~(1<<PB6);									// set MISO input
	PORTB = (1<<PB7) | (1<<PB0);						// SCK,PB0 high (SS an Slave)
	SPCR = (1<<SPE) | (1<<MSTR) | (1<<SPR0);			// Enable SPI, Master, set clock rate fck/16
}

void spi_putc (unsigned char data) {
	
	PORTB &= ~(1<<PB0);								//Beginn der bertragung, SS am slave auf low
	SPDR = data;										//start transmission
	while (!(SPSR & (1<<SPIF)));						//wait for transmission complete
	PORTB |= (1<<PB0);									//Ende der bertragung, SS am slave auf high
	
}

int main (void) 
{
	spi_master_init ();					//SPI initialisieren
	sei ();								//Interrupts zulassen
	spi_puts("Test abc123");			//Zeichenfolge senden
	for (;;);
	return 0;
}
