/**************************************************************
SPI-Slave Demo Programm
B. Hayer 16.06.2005
Empfngt Daten ber SPI und gibt sie ber UART aus.
				MISO(Master) -> MISO(Slave)
				MOSI(Master) -> MOSI(Slave)
				SCK(Master)  -> SCK(Slave)
				PB4(Master)	 -> SS(Slave)
**************************************************************/

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/signal.h>

#include "uart.h"

#ifndef F_CPU
#define F_CPU 8000000UL
#endif
#define UART_BAUD_RATE      19200

volatile unsigned char data;

SIGNAL (SIG_SPI)								//SPI Interrupt Service-Routine
{
	data = SPDR;								//empfangenes byte auslesen
	uart_putc(data);							//und ueber UART ausgeben
}

void spi_slave_init (void)
{
	DDRB = (1<<PB6);							//set MISO output
	SPCR = (1<<SPE) | (1<<SPIE);				//Enable SPI + Interrupt
}

int main (void)
{

	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE,F_CPU) );	//UART initialisieren
	uart_putc('T');								//"Lebens-"Zeichen ausgeben
	spi_slave_init ();							//SPI initialisieren
	sei ();										//enable interrputs


	for (;;);
	return 0;
}
